/* libfir/src/libfir++/100_fir.h
 * 
 *  Copyright: ©2014, Laurence Withers.
 *  Author: Laurence Withers <l@lwithers.me.uk>
 *  License: GPLv3
 */



/*! \defgroup libfirpp_fir Basic FIR filtering

\ingroup libfirpp

\todo need our own symmetry enum
\todo forward declares
\todo coefficient query

*/



/*! \brief Basic FIR filter object.

\ingroup libfirpp_fir

*/
class Filter {
public:
    Filter(int ncoeff, double* coeff,
        enum fir_symmetry symm = fir_symmetry_none);
    Filter(const Filter& other);
    Filter(const std::vector<double>& coeff,
        enum fir_symmetry symm = fir_symmetry_none);
    virtual ~Filter();

private:
    struct fir_filter_t* fi_;

    // disallow assignment
    Filter& operator=(const Filter& other);
};



/* options for text editors
vim: expandtab:ts=4:sw=4:syntax=cpp.doxygen
*/
